package com.example.jpa;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;
import static org.junit.Assert.assertTrue;

import java.util.List;

import org.junit.Before;
import org.junit.Test;

import com.example.AddressBook;
import com.example.domain.Person;
import com.example.jpa.JpaAdressBook;

public class AddressBookJpaTest {

	private AddressBook adressBook;

	@Before
	public void setUp() {
		this.adressBook = new JpaAdressBook();
	}
	
	@Test
	public void testAddPerson() throws Exception
	{
	    
	    Person p = new Person();
	    p.setFirstName("Example Name");
		assertNull("Id bereits vor persist() gesetzt", p.getId());

		//insert
		adressBook.addPerson(p);
		assertNotNull("Id nach persist() noch nicht gesetzt", p.getId());
	}
	
	@Test
	public void testAddAndGet() throws Exception
	{
	    Person p = new Person();
		p.setFirstName("Hilde");
		p.setLastName("Hirsch");
		assertNull("Id bereits vor persist() gesetzt", p.getId());

		//insert
		adressBook.addPerson(p);
		assertNotNull("Id nach persist() noch nicht gesetzt", p.getId());
		
		//select
		List<Person> persons = adressBook.getPersons();
		
		System.out.println("Gefundene Personen: " + persons);
		assertTrue("Keine Person gefunden", persons.size() > 0);

		Person lastPerson = persons.get(persons.size() - 1);
		assertNotNull(lastPerson.getId());
		assertEquals("Hilde", lastPerson.getFirstName());
		assertEquals("Hirsch", lastPerson.getLastName());
	}
}
